#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global.h"
#include "functions.h"
#include "plist.h"

double transition_probability(double *from, double *to){
  int underlier, constant = -1;
  double  exponential, growth;

  if(constant == -1){
    Distribution_constant = pow(2*3.14159265359,Dimensions);
    for(underlier=0; underlier<Dimensions; underlier++){
      Distribution_constant *= Covariance[underlier][underlier];
    }
    Distribution_constant = 1.0/sqrt(Distribution_constant);
    constant = 1;
  }

  exponential = 0;
  for(underlier=0; underlier<Dimensions; underlier++){
    growth = log(to[underlier]/from[underlier]) + Covariance[underlier][underlier]/2;
    exponential += (growth - Dividend_adjusted_mean[underlier])* (growth - Dividend_adjusted_mean[underlier])/Covariance[underlier][underlier];
  }
  exponential = exp(-0.5*exponential);

  return(Distribution_constant*exponential);
}
